import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.Timer;
import java.io.File;
import javax.imageio.*;
import javax.imageio.ImageIO;
import java.awt.Image;
import java.awt.image.BufferedImage;

public class Client {

 //RTP variables:
  //----------------
  DatagramPacket rcvdp; //UDP packet received from the server
  DatagramSocket RTPsocket; //socket to be used to send and receive UDP packets
  static int RTP_RCV_PORT = 25000; //port where the client will receive the RTP packets
    
  byte[] buf; //buffer used to store data received from the server `
  
  final static int TEST   = 7;
  final static int SENDHI = 8;
  final static int TILES  = 9;
  final static int SENDTILES = 10;

  
  Socket RTSPsocket; 
  
  static BufferedReader RTSPBufferedReader;
  static BufferedWriter RTSPBufferedWriter;
  static PrintWriter RTSPBufferedPrinter;
  
  static int RTSPSeqNb = 0; //Sequence number of RTSP messages within the session
  int RTSPid = 0; //ID of the RTSP session (given by the RTSP Server)

  final static String CRLF = "\r\n";


  public Client() {
	    buf = new byte[40000]; 
  }

  public static void main(String argv[]) throws Exception
  {
    
    Client theClient = new Client();
      
    int RTSP_server_port = 4444; //Integer.parseInt(argv[1]);
    //String ServerHost = "creative.csnet.cs.odu.edu"; //argv[0];
    //InetAddress ServerIPAddr = InetAddress.getByName(ServerHost);

    //Establish a TCP connection with the server to exchange RTSP messages
    //------------------
    theClient.RTSPsocket = new Socket("localhost", RTSP_server_port);

    //Set input and output stream filters:
    RTSPBufferedReader = new BufferedReader(new InputStreamReader(theClient.RTSPsocket.getInputStream()) );
    RTSPBufferedWriter = new BufferedWriter(new OutputStreamWriter(theClient.RTSPsocket.getOutputStream()) );
    RTSPBufferedPrinter = new PrintWriter(theClient.RTSPsocket.getOutputStream(),true);
   
	// theClient.send_RTSP_request("TEST");
	 
	// int rcode = theClient.parse_server_response();
	 //theClient.send_RTSP_request("TILES");
	// theClient.parse_server_response();
	 // rcode = theClient.parse_server_response();
	 //Wait for the response 
	  /*	if ( rcode != 200)
	    System.out.println("Invalid Server Response");
	  	else 
	    {
	      //change RTSP state and print new state 
	      //state = ....
	      System.out.println("New RTSP state: ....SENDING TILES \n");
	    }
	
	 
	 theClient.send_RTSP_request("SENDTILES");
	 rcode = theClient.parse_server_response(); */
	 theClient.receiveTile(); 

  }  // end of MAIN

 //------------------------------------
  //Parse Server Response
  //------------------------------------
  private int parse_server_response() 
  {
    int reply_code = 0;

    try{
      //parse status line and extract the reply_code:
      String StatusLine = RTSPBufferedReader.readLine();
      System.out.println("RTSP Client - Received from Server:");
      System.out.println(StatusLine);
	  	    
      StringTokenizer tokens = new StringTokenizer(StatusLine);
      tokens.nextToken(); //skip over the RTSP version
      reply_code = Integer.parseInt(tokens.nextToken());
      
      //if reply code is OK get and print the 2 other lines
      if (reply_code == 200)
	{
	  String SeqNumLine = RTSPBufferedReader.readLine();
	  System.out.println(SeqNumLine);
	  
	  String SessionLine = RTSPBufferedReader.readLine();
	  System.out.println(SessionLine);
	
	  //if state == INIT gets the Session Id from the SessionLine
	  tokens = new StringTokenizer(SessionLine);
	  tokens.nextToken(); //skip over the Session:
	  RTSPid = Integer.parseInt(tokens.nextToken());
	} 
    }
    catch(Exception ex)
      { System.out.println("Exception caught: "+ex); System.exit(0); } 
    
  return(reply_code);
  }  // end of Parse Server Response


private int parse_server_response_TYPE() 
  {
    int reply_code = 0;

    try{
      //parse status line and extract the reply_code:
      String StatusLine = RTSPBufferedReader.readLine();
      System.out.println("RTSP Client - Received from Server:");
      System.out.println(StatusLine);
	  
    }
    catch(Exception ex)
      { System.out.println("Exception caught: "+ex); System.exit(0); } 
    
  return(reply_code);
  }  // end of Parse Server Response


  //------------------------------------
  //Send RTSP Request
  //------------------------------------
  private void send_RTSP_request(String request_type)
  {
    try{
      int lenT = request_type.length();
	  System.out.println(request_type);
      RTSPBufferedWriter.write(request_type+"\n"); 
      //RTSPBufferedPrinter.println(request_type);
      RTSPSeqNb ++;
     // RTSPBufferedWriter.write("ReqTYPE: "+request_type+CRLF); //"\n"); //,0,lenT);
      RTSPBufferedWriter.write("CSeq: "+RTSPSeqNb+CRLF);
      RTSPBufferedWriter.write("Session: "+RTSPid+CRLF);
      RTSPBufferedWriter.flush();
      System.out.println("Flushed Successfully");
      //while(true);
    }
    catch(Exception ex)
      {
	System.out.println("Exception caught: "+ex);
	System.exit(0);
      }
  } // end of SEND RTSP Request
    
  //------------------------------------
  //Handler to receive Tiles
   
   public void receiveTile() {
      
      //System.out.println("I am inside receiveTiles \n");
      try{
      RTPsocket = new DatagramSocket(RTP_RCV_PORT );	
      //Construct a DatagramPacket to receive data from the UDP socket
      rcvdp = new DatagramPacket(buf, buf.length);
      //System.out.println("Before Receive\n:");
		try {
	Thread.sleep(1000);
	}
	catch ( InterruptedException e) { }
	RTPsocket.receive(rcvdp);
	  //System.out.println("After Receive\n:");
	//create an RTPpacket object from the DP
	RTPpacket rtp_packet = new RTPpacket(rcvdp.getData(), rcvdp.getLength());
	
	System.out.println("Got RTP packet with SeqNum # "+rtp_packet.getsequencenumber()+" TimeStamp "+rtp_packet.gettimestamp()+" ms, of type "+rtp_packet.getpayloadtype());
	
	//print header bitstream:
	rtp_packet.printheader();

	//get the payload bitstream from the RTPpacket object
	int payload_length = rtp_packet.getpayload_length();
	byte [] payload = new byte[payload_length];
	rtp_packet.getpayload(payload);
	imgBytes b = new imgBytes();	 
	BufferedImage img = b.getImage(payload);
	File file1 = new File("captt.jpg");
	ImageIO.write(img, "JPG", file1);	
	}
      catch (InterruptedIOException iioe){
	
      }
      catch (IOException ioe) {
	System.out.println("Exception caught: "+ioe);
      }
    } ///end of receive tile
 
  //////////////////////end of receiver//////////////////////////
} // end of Client Class