import java.io.*;
import java.net.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.Timer;
import java.io.File;
import javax.imageio.*;
import javax.imageio.ImageIO;
import java.awt.Image;
import java.awt.image.BufferedImage;

public class Server {

  //RTP variables:
  //----------------
  DatagramSocket RTPsocket; //socket to be used to send and receive UDP packets
  DatagramPacket senddp; //UDP packet containing the video frames

  InetAddress ClientIPAddr; //Client IP address
  int RTP_dest_port = 0; //destination port for RTP packets  (given by the RTSP Client)
  static int RTPPORT = 4499; 	
  static int RTP_RCV_PORT = 20000;
  static int TIME_PERIOD = 100;
  static int timestamp = 472998495;
 
  
  int imagenb = 0; //image nb of the image currently transmitted
  static int IMAGE_TYPE = 97;  

  
  byte[] buf; //buffer used to store the images to send to the client 
  //rtsp message types
  
  final static int TEST = 7;
  final static int SENDHI = 8;
  final static int TILES = 9;
  final static int SENDTILES = 10;

  Socket RTSPsocket; //socket used to send/receive RTSP messages
  //input and output stream filters
  static BufferedReader RTSPBufferedReader;
  static BufferedWriter RTSPBufferedWriter;
  
  static int RTSP_ID = 123456; //ID of the RTSP session
  int RTSPSeqNb = 0; //Sequence number of RTSP messages within the session
  
  final static String CRLF = "\r\n";

//--------------------------------
//Constructor
//--------------------------------
 public Server(){

    //allocate memory for the sending buffer
    buf = new byte[40000]; 
 }
          
  //------------------------------------
  //main
  //------------------------------------
  public static void main(String argv[]) throws Exception
  {
    //create a Server object
    Server theServer = new Server();

    //get RTSP socket port from the command line
    int RTSPport = Integer.parseInt(argv[1]); 
    RTP_RCV_PORT = Integer.parseInt(argv[2]);
    String destinationIP = argv[0];
   
    //Initiate TCP connection with the client for the RTSP session
    ServerSocket listenSocket = new ServerSocket(RTSPport);
    //CCC  theServer.RTSPsocket = listenSocket.accept();
    
	//boolean test = theServer.RTSPsocket.isConnected(); 
	//System.out.println(test);
    //Get Client IP address
   //CCC theServer.ClientIPAddr = theServer.RTSPsocket.getInetAddress();
	
   //Set input and output stream filters:
   // RTSPBufferedReader = new BufferedReader(new InputStreamReader(theServer.RTSPsocket.getInputStream()) );
    //RTSPBufferedWriter = new BufferedWriter(new OutputStreamWriter(theServer.RTSPsocket.getOutputStream()) );

    //Wait for the SETUP message from the client
    int request_type;
    boolean done = false;
    /*
    while(!done)
    {
    //System.out.println("Getting data from Client\n");
	request_type = theServer.parse_RTSP_request(); 
	
	if (request_type == TEST ) {
		//init RTSP sequence number
	  	//RTSPSeqNb = 1;
		System.out.println("Request TYPE is TEST Now ");
		theServer.send_RTSP_response();
		
		
		}
	
	if (request_type == TILES)
	  {
	    done = true;
		  System.out.println("INSIDE TILES");
   
   			
	    //Send response
	    theServer.send_RTSP_response();
   		System.out.println("Sending rtp response.\n");
	     //init RTP socket
	    theServer.RTPsocket = new DatagramSocket();
	  }
      }
      
      
      boolean flag = true;
       while(flag)
      {
	//parse the request
	request_type = theServer.parse_RTSP_request(); //blocking
	    
	if ((request_type == SENDTILES) )
	  {
	    //send back response
	    theServer.send_RTSP_response();
	    
	    
	    //update state
	    flag = false;
	    
	    theServer.sendTiles();
	    System.out.println("New RTSP state: SENDING TILES");
	  }
	 }
	 */
	 boolean flag = true;
	 theServer.RTPsocket = new DatagramSocket(Integer.parseInt(argv[1]));
	 while (flag)
	 theServer.sendTiles(destinationIP);
	 //System.out.println("Outside Main\n");
 } // end of main


 //-------------------------------------
  //SendTiles///////////////////
  //------------------------------------
  public void sendTiles(String ip) {
  	
  //	String ip = "handson-233-a.csnet.cs.odu.edu";
  	ip = "128.82.5.57";
    try 
    {
    imgBytes b = new imgBytes();	
    File file = new File("Hair.jpg");
	BufferedImage image = ImageIO.read(file);
	buf = b.getBytes(image);
		
	imagenb++;     
	//System.out.println(imagenb);

	
	 int image_length = buf.length; 
	 //System.out.println("Image length = "+image_length);
	 double t;	
	 //t = (new Date()).getTime();
	 //System.out.println(t);
	 
	 int tm = imagenb*TIME_PERIOD;
	  //Builds an RTPpacket object containing the frame
	  RTPpacket rtp_packet = new RTPpacket(IMAGE_TYPE, imagenb, timestamp, buf, 1450);
	  timestamp++;
	  //get to total length of the full rtp packet to send
	  int packet_length = rtp_packet.getlength();

	  //retrieve the packet bitstream and store it in an array of bytes
	  byte[] packet_bits = new byte[packet_length];
	  rtp_packet.getpacket(packet_bits);

	  //send the packet as a DatagramPacket over the UDP socket 
	  senddp = new DatagramPacket(packet_bits, packet_length, InetAddress.getByName(ip), RTP_RCV_PORT);
	  //System.out.println("Contents of senddp"+senddp.getData());
	  //System.out.println("RTPSocket Value is ="+RTPsocket);
	  RTPsocket.send(senddp);
	   
	  rtp_packet.printheader();
	  //System.out.println("Sent Datagram Packet\n");
	  
	  
	}
	catch(Exception ex)
	  {
	    System.out.println("Exception caught: "+ex);
	    System.exit(0);
	  }
    }
  
   
    //------------------------------------
  //Parse RTSP Request
  //------------------------------------
 private int parse_RTSP_request()
 {
    int request_type = -1;
    try{
      //parse request line and extract the request_type:
      //System.out.println("I am inside parsing data");
      String RequestLine = RTSPBufferedReader.readLine();
      //System.out.println("RTSP Server - Received from Client:");
     // System.out.println(RequestLine);

      StringTokenizer tokens = new StringTokenizer(RequestLine);
      //System.out.println("Printing tokens\n"+tokens);
      String request_type_string = tokens.nextToken();
      
	  //String request_type_string = RequestLine;	
      //convert to request_type structure:
      if ((new String(request_type_string)).compareTo("TEST") == 0) {
      //System.out.println("Got TEST packet\n");
	request_type = TEST;
}
      else if ((new String(request_type_string)).compareTo("SENDTILES") == 0) {
 			//System.out.println("I am inside sendtiles");     	
	request_type = SENDTILES;
}      
      else if ((new String(request_type_string)).compareTo("TILES") == 0)
      {
    //System.out.println("I M in TILES");
	request_type = TILES;
}

      //parse the SeqNumLine and extract CSeq field
      String SeqNumLine = RTSPBufferedReader.readLine();
      //System.out.println("Prasing seqnumline "+SeqNumLine);
      tokens = new StringTokenizer(SeqNumLine);
      tokens.nextToken();
      RTSPSeqNb = Integer.parseInt(tokens.nextToken());
	
      //get LastLine
      String LastLine = RTSPBufferedReader.readLine();
      //System.out.println(LastLine);
    }  // end of try
	catch(Exception ex)
      { System.out.println("Exception caught while Parsing RTSP request: "+ex); System.exit(0); }
    return(request_type);
  } // end of RTSP Request

  //------------------------------------
  //END of Parse RTSP Request
  //------------------------------------

  //------------------------------------
  //Send RTSP Response
  //------------------------------------
  private void send_RTSP_response()
  {
  	RTSPSeqNb++;
    try{
      RTSPBufferedWriter.write("RTSP/1.0 200 OK"+CRLF);
      RTSPBufferedWriter.write("CSeq: "+RTSPSeqNb+CRLF);
      RTSPBufferedWriter.write("Session: "+RTSP_ID+CRLF);
      RTSPBufferedWriter.flush();
      //System.out.println("RTSP Server - Sent response to Client.");
    }
    catch(Exception ex)
      { System.out.println("Exception caught while Sending RTSP request: "+ex); System.exit(0);  }
  }  // end of send_RTSP_response.
 //------------------------------------
  // END of Send RTSP Response
  //------------------------------------

} // end of Server class



